{
   Test_05.Spin

   Check out the communications with RB using the
   Propeller Plug instead of the programming port.

   The PP is connected to P0 (Rx) and P1(Tx).

   Test by reading the Pushbuttons and sending the
   value as a number to RB.
   
}
CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
 RB_TX      = 1           'use RB through the 
 RB_RX      = 0           'propeller plug
 RB_BAUD    = 115200


OBJ
  RB    : "FullDuplexSerial"    'serial driver

PUB Main
  dirA[23..16]~~
  RB.Start(RB_RX,RB_TX,0,RB_BAUD)   'start the serial driver
  repeat 5
    outA[23..16] := %10101010
    waitcnt(clkfreq/4+cnt)    
    outA[23..16] := !(%10101010)
    waitcnt(clkfreq/4+cnt)
    outA[23..16]~
  repeat
     outA[23..21] := inA[7..5]  'output = input
     RB.Tx(inA[7..5])           'transmit the value to RB
 