{
   Program_03.Spin

   Sits in a loop waiting for a byte from RB
   it uses that byte to set the state of P23..16
   then sends a byte out to RB of the value of P7..5

   For Now we will use the same USB port on the Propeller as
   the programming one....is P30 and P31

   Make sure to use F11 (save to EEPROM) not F10 (save to RAM)                    
}
CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  RB_TX    = 30
  RB_RX    = 31
  RB_BAUD  = 115200
OBJ
  RB     : "FullDuplexSerial"
PUB Main
  RB.Start(RB_RX,RB_TX,0,RB_BAUD)
  dirA[16..23]~~
  repeat
     OutA[23..16] := RB.RX   'receive the byte and set the LEDs
     RB.TX(inA[7..5])        'read the buttons and send the states