{
   Blinker_04.Spin
   Blink at different rates three LEDs on P23..21

   If a pushbutton on P5 is pressed the P23 LED
   will move over to P18 until the button is released. 

}
CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

Dat
   ratesV long 200,500,1000  'blinking rates in milliseconds
   Pins   byte 23,22,21      'pin used for LEDs

Var
  long rates[3],timers[3]
  
PUB Main|i
  dirA[16..23]~~            'set pins as output
  repeat i from 0 to 2
     rates[i] := ratesV[i] * (clkfreq/1000)
     timers[i] := cnt
     
  repeat
     if inA[5]              'if NOT button pushed
       Pins[0] := 23        'blink LED on P23 
       outA[18]~
     else
       Pins[0] := 18        'if pushed then blink LED on P18
       outA[23]~
     repeat i from 0 to 2   'check time out for the blinking
        if cnt-timers[i] > rates[i]
           !outA[Pins[i]]
           Timers[i] := cnt                           