{
   Program_04.Spin

   Sits in a loop waiting for a byte from RB
   in the MAIN routine...when a byte comes in it
   calls a routine which does the work of setting
   the LEDs on P23..16.
   
   Also another module is called to do the work of
   reading the bits on P7..5 and puts the value byte.
   This byte is later used to send the value to RB.

   Notice the use of RxCheck instead of Rx to allow for Polling
   later on.
   
   Notice how the ADDRESS of the memory areas is passed to the
   routines....this is not needed here but will be later.
   
   For Now we will use the same USB port on the Propeller as
   the programming one....is P30 and P31                 

   Make sure to use F11 (save to EEPROM) not F10 (save to RAM)
}

CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  RB_TX    = 30
  RB_RX    = 31
  RB_BAUD  = 115200

Var
  byte ReceivedByte, ByteToSend
    
OBJ
  RB     : "FullDuplexSerial"
  
PUB Main|x
  RB.Start(RB_RX,RB_TX,0,RB_BAUD)
  dirA[16..23]~~
  repeat
     repeat
         x := RB.RXcheck
     until x <> -1
     ReceivedByte := x    
     SetLEDs(@ReceivedByte)
     ReadPins(@ByteToSend)          
     RB.TX(ByteToSend)

Pri SetLEDs(ReceivedByteAddr)
  outA[23..16] := Byte[ReceivedByteAddr]

Pri ReadPins(ByteToSendAddr)
  Byte[ByteToSendAddr] := inA[7..5]  
