{
   Program_04_B.Spin
   
   04 but with blinker....
   it is faulty where the blinker works but only
   until the first byte arrives then stops.

   fix by moving line 29 to immediately prior to the
   first repeat statement (line28) 
   
   Make sure to use F11 (save to EEPROM) not F10 (save to RAM)
}
CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  RB_TX    = 30
  RB_RX    = 31
  RB_BAUD  = 115200
  Blink_Time = 160_000_000   '2 secs

Var
  byte ReceivedByte, ByteToSend  
OBJ
  RB     : "FullDuplexSerial"
PUB Main|x,t
  RB.Start(RB_RX,RB_TX,0,RB_BAUD)
  dirA[16..23]~~
  repeat
     t := cnt                  'init timer
     repeat
        't := cnt               'init timer
        x := RB.RXcheck
        if (cnt-t)> Blink_Time 'if timeout
          !outA[23]            'toggle LED
          t := cnt             'reset timer
     until x <> -1  
     ReceivedByte := x    
     SetLEDs(@ReceivedByte)
     ReadPins(@ByteToSend)
     RB.TX(ByteToSend)

Pri SetLEDs(ReceivedByteAddr)
  outA[22..16] := Byte[ReceivedByteAddr]

Pri ReadPins(ByteToSendAddr)
  Byte[ByteToSendAddr] := inA[7..5]  