{
   Trap_1.Spin
   an example of how parallelism can cause
   puzzling errors
}
CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
 D_TX      = 30
 D_RX      = 31
 D_BAUD    = 115200


OBJ
  D    : "SerialMirror"    'serial driver

Var
  Long Stack[20], sharedVar         
PUB Main
  dirA[23..16]~~
  D.Start(D_RX,D_TX,0,D_BAUD)   'start the serial driver
  CogNew(CogProcess,@Stack)
  repeat
     if not inA[7]
        sharedVar := -1
     if not inA[5]
       sharedVar :=0


Pri CogProcess|x
   dirA[23..16]~~
   repeat
      if sharedVar <> -1
         outA[23]~~
         x := (x+1)// $1_0000
         if x == 0
            !outA[16]
         D.Str(string(13,"Working "))
         D.Dec(x)
         waitcnt(clkfreq+cnt)
         sharedVar := 2
      else
         outA[23]~
         outA[16]~
         D.Str(string(13,"not doing anything "))
         D.Dec(x)   