//Program_11_ReallySimple.Bas
//works with Program_11_Main.Spin
Port = 8 //change this as per your system
Main:
  Gosub Initialization
  while true
     if keydown(kc_Esc) then call SendCommand(0,0) \ break
     call SendCommand(6,0)    //set forward
     call SendCommand(192,0)  //get ping
     if Ping < 500
        repeat
           if keydown(kc_Esc) then call SendCommand(0,0) \ break  
           call SendCommand(7,0)   //set backward
           call SendCommand(192,0) //get ping   
        until Ping > 1000
     endif
  wend
End
//-------------------------------------------
Initialization:
  setcommport Port,br115200
  Ping = 0 
Return
//-------------------------------------------
sub SendCommand(C,P)
   clearserbuffer
   serialout C,P
   serbytesin 5,s,n
   if n < 5
      s=""
      xystring 500,40,"Comms Error"
      return false
   endif
   if C ==192  //if command is ping make up number and convert to mm
      call mmDistance(,GetStrByte(s,5)+(getstrbyte(s,4)<<8),x)
      _Ping = x
      xystring 10,30,"Ping = ",x,spaces(20)
   endif   
return true
//-----------------------------------------
sub mmDistance(Tc,t,&D)  //convert ping to mm
   if !vType(Tc) then Tc = 22.2        //if no temp specified assume 22.2 C
   D = 0.5*t*(331.5 + 0.6* Tc)/1000  //convert time to mm
Return D
//-----------------------------------------
