{
  Servomotor_03.Spin

  Drives 2 servomotors on P16..P17 (or just LED)
  But uses a Cog

}
CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  Blinker = 23
  Steps   = 10
  MinVal  = 1000
  MaxVal  = 2000
  MidVal  = 1500
  
Var
   long Stack[10],Pulse[2],Inc[2]

PUB Main|i,t[2]
  Pulse[0] := Pulse[1] := MidVal
  Inc[0] := Steps
  Inc[1] := -Steps
  cognew(Servos(16,17,@Pulse),@Stack) 'start the servomotor driver
  dirA[Blinker]~~
  t[0] := t[1] := cnt
  repeat
    if cnt - t[0] > clkfreq
      t[0] := cnt
      !outA[Blinker]
    if cnt-t[1] > clkfreq/10
      t[1] := cnt
      repeat i from 0 to 1
        Pulse[i] += inc[i]
        if Pulse[i] => MaxVal or Pulse[i] =< MinVal 
          Inc[i] := -Inc[i]
          
  
Pri Servos(ServoPin0,ServoPin1,Pulses)
  dirA[ServoPin0]~~                      'set pins as output
  dirA[ServoPin1]~~
  repeat
    outA[ServoPin0]~~
    waitcnt(cnt+Long[Pulses][0]*(clkFreq/1_000_000))
    outA[ServoPin0]~
    outA[ServoPin1]~~
    waitcnt(cnt+Long[Pulses][1]*(clkFreq/1_000_000))
    outA[ServoPin1]~
    waitcnt(cnt+(20_000-Long[Pulses][0]-Long[Pulses][1])*(clkfreq/1_000_000))
 