{
   Test_03.Spin

   Check that the PST works as a good display
   for the workings of the Proepller.

   Test by reading the Pushbuttons and reflect
   their states on the PST

   Also demonstrate the effect of floating input
   by using P4 that is not connected. Connect a wire
   to it but do not connect the other end to anything.

   Now touch the wire and observe.
}
CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
 D_TX      = 30
 D_RX      = 31
 D_BAUD    = 115200

 LastPin   = 5     'change this to 4 to observe floating Input effect


OBJ
  D    : "SerialMirror"    'serial driver

PUB Main
  dirA[23..16]~~
  D.Start(D_RX,D_TX,0,D_BAUD)   'start the serial driver
  repeat 5
    outA[23..16] := %10101010
    waitcnt(clkfreq/4+cnt)    
    outA[23..16] := !(%10101010)
    waitcnt(clkfreq/4+cnt)
    outA[23..16]~
  repeat
     outA[23..20] := inA[7..LastPin]  'output = input ...notice extra bit
     D.Dec(inA[7..LastPin])           'transmit the value to PST
 