{
   Program_06.Spin

   Same as Program_05_E but divided into objects.
   Also making each Cog do its own Blinker
   
}
CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  RB_TX       = 1
  RB_RX       = 0
  RB_BAUD     = 115200
  D_TX        = 30
  D_RX        = 31
  D_BAUD      = 115200
  Blinker     = 23
  
OBJ
  RB     : "FullDuplexSerial"
  D      : "SerialMirror"
  Set    : "Program_06_Set"    'our object
  Read   : "Program_06_Read"   'our object
  
PUB Main|x,t
  RB.Start(RB_RX,RB_TX,0,RB_BAUD)
  D.Start(D_RX,D_TX,0,D_BAUD)
  Set.Start(@ReceivedByte,@Blink_Time) 'start our object
  Read.Start(@ByteToSend,@Blink_Time)  'start our object 
  DirA[Blinker]~~
  t := cnt                        'init timer
  repeat
     repeat
         x := RB.RXcheck
         if (cnt-t)> Blink_Time   'if time out
            !OutA[Blinker]        'toggle LED
            t := cnt              'reset timer
     until x <> -1
     ReceivedByte := x    
     RB.TX(ByteToSend)


Dat
  ReceivedByte Byte 0
  ByteToSend   Byte 0
  Blink_Time   Long 80_000_000   '1 sec
  Blink1_Time  Long 160_000_000  '2 secs 2*80_000_000
  Blink2_Time  Long 240_000_000  '3 secs 3*80_000_000

