{
   Program_08_Read.Spin

   object used by Program_08.Spin   
}
CON
  Blinker    = 22
  FlagMask   = %0000_0001

Var
  long Stacks[50]

Obj
  D      : "SerialMirror"
  
PUB Start(ByteToSend,Rates,Semaphore)
  cogNew(ReadPins(ByteToSend,Rates,Semaphore),@Stacks[0])

Pri ReadPins(ByteToSend,Rates,Semaphore)|t
  dirA[Blinker]~~
  t := cnt                          'initialize the timer
  repeat
      if (cnt-t) => Long[Rates][1]  'blinker time out 2 secs
          !outA[Blinker]            'toggle the LED
          t :=cnt                   'reset the timer
      Byte[ByteToSend] := inA[7..5]
      if byte[Semaphore][1] & FlagMask   'only output to PST if flagged to do so
        if Not LockSet(byte[Semaphore])  'only send if can acquire the semaphore
           D.Str(string(13,"Read:"))
           D.Dec(byte[ByteToSend])
           byte[Semaphore][1] &= !FlagMask 'clear the flag                                  
           LockClr(byte[Semaphore])        'clear the semaphore