{
  Pots_02.Spin
  Sends the data to RB using the MSByte First
  Waits for RB to signal wanting the Data
  Reads the Ports and then sends the data.

  It also outputs to the PST for debug purposes.

}
Con                                                   
  _clkmode = xtal1 + pll16x                           
  _xinfreq = 5_000_000                                
 RB_TX     = 1
 RB_RX     = 0
 RB_BAUD   = 115200
 D_TX      = 30
 D_RX      = 31
 D_BAUD    = 115200
 RCPin1    = 3                                            
 RCPin2    = 2                                           
                                                      
Var                                                   
  Long RCTime[2]                                         
                                                      
Obj                                                   
  RB    : "FullDuplexSerial"                          
  D     : "SerialMirror"                          
  RC    : "Pots_RCTime"                                
                                                      
Pub Main|i                                              
  RB.Start(RB_RX,RB_TX,0,RB_Baud)                         
  D.Start(D_RX,D_TX,0,D_Baud)                         
  waitcnt(ClkFreq/10+cnt)                              
  repeat
    RB.RX
    RC.RCTime(RCPin1,1,@RCTime[0])   'use Pots_RCTime in direct mode ...no cog                                              
    RC.RCTime(RCPin2,1,@RCTime[1])   'to get one-time reading...                                              
    D.Tx(16)                         'clear the PST screen                    
    D.Dec(RCTime[0])                 'output first pot's time value
    D.TX(13)                         'line feed
    D.Dec(RCTime[1])                 'output second pot's time value
    repeat i from 0 to 1
      RB.Tx((RCTime[i]>>8)&$FF)
      RB.Tx(RCTime[i] & $FF)                    
    waitcnt(ClkFreq/2+cnt)                            
