//RobotMoves_12.Bas
//works with Program_12_Main.Spin
Port =16  //change this as per your system
Main:
  Gosub Initialization
  while true
     call SendCommand(6,20)    'forward
     call DisplayData()
     call SendCommand(12,90)   'turn right
     call DisplayData()
     call SendCommand(7,20)    'backward
     call DisplayData()
     call SendCommand(13,90)   'turn left    
     call DisplayData()
  wend   
end
//------------------------------
Initialization:
  Bumper = 0 \ Feel = 0 \ Sense = 0
  GPSx = 0 \ GPSy = 0 \  Ranger = 0
  setcommport Port,br115200
  //call DoCommand(240,255) 'L_Speed
  //call DoCommand(241,10)  'L_TimeOut
  //call DoCommand(242,5)   'StepTime
  //call DoCommand(243,2)   'TurnTime
Return
//------------------------------
sub SendCommand(C,P,&s)
   serialout C,P
   serbytesin 5,s,x
   if x != 5 then xystring 10,100,"Comms Error" \ return false
   if C != 66
      _Bumper = getstrbyte(s,1)
      _Feel   = getstrbyte(s,2)
      _Sense  = getstrbyte(s,3)
   endif
   if C==192
      _Ranger = getstrbyte(s,5)+(getstrbyte(s,4)<<8)
   elseif C==66
      _GPSx = getstrbyte(s,2)+(getstrbyte(s,1)<<8)
      _GPSy = getstrbyte(s,4)+(getstrbyte(s,3)<<8)
   endif      
return true
//--------------------------------
sub DisplayData()
  xystring 10,10,"Bumper";"Feel";"Sense";"Ranger";"GPSx";"GPSy"
  Call SendCommand(66,0)    'pots
  Call SendCommand(192,0)   'ping
  xystring 10,30,_Bumper; _Feel; _Sense;_Ranger;_GPSx;_GPSy,spaces(10)
return
