//Compass_Animation_TCP.Bas
//works with Protocol_Main.Spin
//but over the LAN or internet
TCPS_IP = "192.168.0.198" \ TCPS_Port = 50000
tcpc_Connect(TCPS_IP,TCPS_Port)
Port = 0  //change this as per your system
#include "..\Utilities&IncludeFiles\Instruments.Bas"
//-----------------------------------------
Main:
   setcommport Port,br115200
   flip on
   call SendCommand(24,1,s)  //see if there is a compass
   if SendCommand__Result
      if !getstrbyte(s,5) then print "no compass available" \Terminate
   endif
   //uncomment the following three lines to invoke a manual calibration
   //print "Calibration in progressrotate two turns while level"
   //call SendCommand(24,2)
   //delay 20000
   AddCheckBox "Mode",430,230,"&Real Mode",1,0
   while true
     call SendCommand(24,0,s)  //read the compass
     if !SendCommand__Result then continue
     x = (getstrbyte(s,4)<<8)+getstrbyte(s,5)
     call DisplayCompass(!GetCheckBox("Mode"),x)
     flip
   wend
end
//-----------------------------------------
sub SendCommand(C,P,&s)
  m = ""
  //serialout C,P
  //serbytesin 5,s,x
  call TCP_SendCommand(C,P,s,x)
  if x < 5 then m= "Comms Error"
  xystring 500,20,m,spaces(30)  
return (x == 5)
//-----------------------------------------


