//animated 3D airplane rotations

data plane;9,.5,6,1.5,4,1.5
data plane;0,8.5,-1,8.5,-1,1.5,-4,.5,-5,3.5,-6,3.5
data plane;-6,-3.5,-5,-3.5,-4,-0.5,-1,-1.5,-1,-8.5,0,-8.5
data plane;4,-1.5,6,-1.5,9,-0.5,9,.5

data Eye;70,pi(1.25),pi(.35),1550,400,300 //rho,theta,phi,d,Cx,Cy
dim Plane[maxdim(plane)/2,5]
mconstant Plane,0
for i=0 to maxdim(plane)/2 -1
  Plane[i,0] = plane[i*2]
  Plane[i,1] = plane[i*2+1]
next
flip on


j=0 \ m=0 \ n=0
while true
  clearscr
  mcopy Plane,K
  geRotateA K,dtor(j),1
  geRotateA K,dtor(m),2  
  geRotateA K,dtor(n),3  
  j += 10 \ m += 2  \ n +=5
  ge3dto2da K,Eye            //calculated screen coordinates
  for i=1 to maxdim(K)-1
    line K[i-1,3],K[i-1,4],K[i,3],K[i,4]
  next
  flip
  delay 100
wend
