//Reference Axis display
data plane;9,.5,6,1.5,4,1.5
data plane;0,8.5,-1,8.5,-1,1.5,-4,.5,-5,3.5,-6,3.5
data plane;-6,-3.5,-5,-3.5,-4,-0.5,-1,-1.5,-1,-8.5,0,-8.5
data plane;4,-1.5,6,-1.5,9,-0.5,9,.5

data coord;0,0,0,0,0, 9,0,0,0,0,  0,9,0,0,0,  0,0,9,0,0
dim Coord[4,5] \ mcopy coord,Coord

data Eye;70,pi(1.25),pi(.35),1550,400,300 //rho,theta,phi,d,Cx,Cy
//data Eye;170,pi(),pi(.30),1550,400,350 //rho,theta,phi,d,Cx,Cy

dim Plane[maxdim(plane)/2,5]
mconstant Plane,0
for i=0 to maxdim(plane)/2 -1
  Plane[i,0] = plane[i*2]
  Plane[i,1] = plane[i*2+1]
next

ge3dto2da Coord,Eye            //calculated screen coordinates
for i= 1 to 3
   line Coord[0,3],Coord[0,4],Coord[i,3],Coord[i,4],2,i
   xytext -1,-1,char(ascii("w")+i)
Next


j=0 \ m=0 \ n=0
mcopy Plane,K
geRotateA K,dtor(j),1
geRotateA K,dtor(m),2  
geRotateA K,dtor(n),3  
j += 10 \ m += 2  \ n +=5
ge3dto2da K,Eye            //calculated screen coordinates
for i=1 to maxdim(K)-1
  line K[i-1,3],K[i-1,4],K[i,3],K[i,4]
next

